%{
/* temp_l.l 
	definition of lexical box for template parser.
*/

#undef output
#define output(c)

%}
%option yylineno
%%

^"//"[^\n]*$			{
#							ifdef TEMP_DEBUG
							printf("Comment: %s\n",yytext); 
#							endif
						}
^"#"[ \t]*[iI][fF][^\n]+$ 	{
#								ifdef TEMP_DEBUG
								printf("IF: %s ",yytext);
#								endif
								return IF_LINE;
							}

^"#"[ \t]*[eE][nN][dD][iI][fF][^\n]*$ 	{
#											ifdef TEMP_DEBUG
											printf("ENDIF: %s ",yytext);
#											endif
											return END_IF; 
										}

^"#"[^\n]*$	{
#				ifdef TEMP_DEBUG
				printf("OTHER: %s",yytext);
#				endif
				return OTHER_LINE; 
			}

"^^"[^^\n]+"^^"	{
					unsigned char *value;

					/* substitute value, leaving outer carets,
						and append to file */
#					ifdef TEMP_DEBUG
					printf("stay_substitute: %s",yytext);
#					endif
					if (copy_out) {
						strcat(tmp_hif,"^");
						yytext[strlen(yytext)-2] = '\0';
						temp_lineno = yylineno;
						value = get_value(&yytext[2]);
						if (get_value_return) {
							temp_lex_return = 1;
							return 0;
						}	
						strcat(tmp_hif,value);
						strcat(tmp_hif,"^");
					}
				}

"^"[^^\n]+"^"	{
					unsigned char *value;

					/* substitute value, deleting carets,
						and append to file */
#					ifdef TEMP_DEBUG
					printf("substitute: %s",yytext);
#					endif
					if (copy_out) {
						yytext[strlen(yytext)-1] = '\0';
						temp_lineno = yylineno;
						value = get_value(&yytext[1]);
						if (get_value_return) {
							temp_lex_return = 1;
							return 0;
						}	
						strcat(tmp_hif,value);
					}
				}

^[ \t]*\n			{ 
						/*  append to file */
#						ifdef TEMP_DEBUG
						printf("cr: %s",yytext);
#						endif
						if (copy_out) {
							strcat(tmp_hif,yytext);
							/* This is one of two spots where linefeeds are written into
								the tmp_hif string, aside from rich text in rep_ex_y.y */
							tmp_to_template[tmp_count++] = yylineno;
						}
					}
[^^\n]+\n			{ 
						/*  append to file */
#						ifdef TEMP_DEBUG
						printf("cr 'space': %s",yytext);
#						endif
						if (copy_out) {
							strcat(tmp_hif,yytext);
							/* This is one of two spots where linefeeds are written into
								the tmp_hif string, aside from rich text in rep_ex_y.y */
							tmp_to_template[tmp_count++] = yylineno;
						}
					}
[^^\n]+			{ 
					/*  append to file */
#					ifdef TEMP_DEBUG
					printf("'space': %s",yytext);
#					endif
					if (copy_out) {
						strcat(tmp_hif,yytext);
					}
				}
.|\n	{}
%%

yywrap() 
{
	return 1;
}
